/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file TMgr_TypeTrackType_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'trackmgr.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_TRACKMGR_TMGR_TYPETRACKTYPE_BASE_HPP
#define OBJECTS_TRACKMGR_TMGR_TYPETRACKTYPE_BASE_HPP

// extra headers
#include <objects/trackmgr/trackmgr_export.h>

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

enum ETMgr_TypeTrackType {
    eTMgr_TypeTrackType_hub            =  0,
    eTMgr_TypeTrackType_altGraphX      =  2,
    eTMgr_TypeTrackType_bam            =  3,
    eTMgr_TypeTrackType_bed            =  4,
    eTMgr_TypeTrackType_bed5FloatScore =  5,
    eTMgr_TypeTrackType_bedGraph       =  6,
    eTMgr_TypeTrackType_bedRnaElements =  7,
    eTMgr_TypeTrackType_bigBarChart    =  8,
    eTMgr_TypeTrackType_bigBed         =  9,
    eTMgr_TypeTrackType_bigPsl         = 10,
    eTMgr_TypeTrackType_bigChain       = 11,
    eTMgr_TypeTrackType_bigMaf         = 12,
    eTMgr_TypeTrackType_bigWig         = 13,
    eTMgr_TypeTrackType_broadPeak      = 14,
    eTMgr_TypeTrackType_chain          = 15,
    eTMgr_TypeTrackType_clonePos       = 16,
    eTMgr_TypeTrackType_coloredExon    = 17,
    eTMgr_TypeTrackType_ctgPos         = 18,
    eTMgr_TypeTrackType_downloadsOnly  = 19,
    eTMgr_TypeTrackType_encodeFiveC    = 20,
    eTMgr_TypeTrackType_expRatio       = 21,
    eTMgr_TypeTrackType_factorSource   = 22,
    eTMgr_TypeTrackType_genePred       = 23,
    eTMgr_TypeTrackType_gvf            = 24,
    eTMgr_TypeTrackType_ld2            = 25,
    eTMgr_TypeTrackType_narrowPeak     = 26,
    eTMgr_TypeTrackType_netAlign       = 27,
    eTMgr_TypeTrackType_peptideMapping = 28,
    eTMgr_TypeTrackType_psl            = 29,
    eTMgr_TypeTrackType_rmsk           = 30,
    eTMgr_TypeTrackType_snake          = 31,
    eTMgr_TypeTrackType_vcfTabix       = 32,
    eTMgr_TypeTrackType_wig            = 33,
    eTMgr_TypeTrackType_wigMaf         = 34,
    eTMgr_TypeTrackType_multiWig       = 35,
    eTMgr_TypeTrackType_vcf            = 36
};

/// Access to ETMgr_TypeTrackType's attributes (values, names) as defined in spec
NCBI_TRACKMGR_EXPORT const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(ETMgr_TypeTrackType)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_TRACKMGR_TMGR_TYPETRACKTYPE_BASE_HPP
