/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Placement.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'search_by_rsid.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: Placement_.hpp


#ifndef OBJECTS_VARIATION_LIBS_DBSNP_SEARCH_BY_RSID_PLACEMENT_HPP
#define OBJECTS_VARIATION_LIBS_DBSNP_SEARCH_BY_RSID_PLACEMENT_HPP


// generated includes
#include <objects/variation_libs/dbsnp/search_by_rsid/Placement_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class CPlacement : public CPlacement_Base
{
    typedef CPlacement_Base Tparent;
public:
    // constructor
    CPlacement(void);
    // destructor
    ~CPlacement(void);

private:
    // Prohibit copy constructor and assignment operator
    CPlacement(const CPlacement& value);
    CPlacement& operator=(const CPlacement& value);

};

/////////////////// CPlacement inline methods

// constructor
inline
CPlacement::CPlacement(void)
{
}


/////////////////// end of CPlacement inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_VARIATION_LIBS_DBSNP_SEARCH_BY_RSID_PLACEMENT_HPP
/* Original file checksum: lines: 86, chars: 2515, CRC32: 2d025ae8 */
