/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Acronym.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: Acronym_.hpp


#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_ACRONYM_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_ACRONYM_HPP


// generated includes
#include <objtools/eutils/efetch/Acronym_.hpp>

// generated classes

BEGIN_eutils_SCOPE // namespace eutils::

/////////////////////////////////////////////////////////////////////////////
class CAcronym : public CAcronym_Base
{
    typedef CAcronym_Base Tparent;
public:
    // constructor
    CAcronym(void);
    // destructor
    ~CAcronym(void);

    // typedef std::string Tdata;

    /// Constructor from the primitive type.
    CAcronym(const Tdata& value);
    /// Assignment operator
    CAcronym& operator=(const Tdata& value);

private:
    // Prohibit copy constructor and assignment operator
    CAcronym(const CAcronym& value);
    CAcronym& operator=(const CAcronym& value);

};

/////////////////// CAcronym inline methods

// constructor
inline
CAcronym::CAcronym(void)
{
}

// data copy constructors
inline
CAcronym::CAcronym(const Tdata& value)
{
    Set(value);
}

// data assignment operators
inline
CAcronym& CAcronym::operator=(const Tdata& value)
{
    Set(value);
    return *this;
}


/////////////////// end of CAcronym inline methods


END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_ACRONYM_HPP
/* Original file checksum: lines: 104, chars: 2747, CRC32: b955a225 */
