/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file DispFormula.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: DispFormula_.hpp


#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_DISPFORMULA_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_DISPFORMULA_HPP


// generated includes
#include <objtools/eutils/efetch/DispFormula_.hpp>

// generated classes

BEGIN_eutils_SCOPE // namespace eutils::

/////////////////////////////////////////////////////////////////////////////
class CDispFormula : public CDispFormula_Base
{
    typedef CDispFormula_Base Tparent;
public:
    // constructor
    CDispFormula(void);
    // destructor
    ~CDispFormula(void);

private:
    // Prohibit copy constructor and assignment operator
    CDispFormula(const CDispFormula& value);
    CDispFormula& operator=(const CDispFormula& value);

};

/////////////////// CDispFormula inline methods

// constructor
inline
CDispFormula::CDispFormula(void)
{
}


/////////////////// end of CDispFormula inline methods


END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_DISPFORMULA_HPP
/* Original file checksum: lines: 82, chars: 2439, CRC32: af0c0eee */
