/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file LocationLabel.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: LocationLabel_.hpp


#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_LOCATIONLABEL_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_LOCATIONLABEL_HPP


// generated includes
#include <objtools/eutils/efetch/LocationLabel_.hpp>

// generated classes

BEGIN_eutils_SCOPE // namespace eutils::

/////////////////////////////////////////////////////////////////////////////
class CLocationLabel : public CLocationLabel_Base
{
    typedef CLocationLabel_Base Tparent;
public:
    // constructor
    CLocationLabel(void);
    CLocationLabel(const std::string& value);
    // destructor
    ~CLocationLabel(void);

    // typedef std::string TLocationLabel;

    /// Conversion operator to 'TLocationLabel' type.
    operator const TLocationLabel&(void) const;
    /// Assignment operator.
    CLocationLabel& operator=(const TLocationLabel& value);

private:
    // Prohibit copy constructor and assignment operator
    CLocationLabel(const CLocationLabel& value);
    CLocationLabel& operator=(const CLocationLabel& value);

};

/////////////////// CLocationLabel inline methods

// constructor
inline
CLocationLabel::CLocationLabel(void)
{
}

inline
CLocationLabel::CLocationLabel(const std::string& value)
{
    SetLocationLabel(value);
}

inline
CLocationLabel::operator const CLocationLabel::TLocationLabel&(void) const
{
    return GetLocationLabel();
}

inline
CLocationLabel& CLocationLabel::operator=(const TLocationLabel& value)
{
    SetLocationLabel(value);
    return *this;
}


/////////////////// end of CLocationLabel inline methods


END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_LOCATIONLABEL_HPP
/* Original file checksum: lines: 109, chars: 3078, CRC32: c8f6148d */
