/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Lt.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: Lt_.hpp


#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_LT_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_LT_HPP


// generated includes
#include <objtools/eutils/efetch/Lt_.hpp>

// generated classes

BEGIN_eutils_SCOPE // namespace eutils::

/////////////////////////////////////////////////////////////////////////////
class CLt : public CLt_Base
{
    typedef CLt_Base Tparent;
public:
    // constructor
    CLt(void);
    // destructor
    ~CLt(void);

private:
    // Prohibit copy constructor and assignment operator
    CLt(const CLt& value);
    CLt& operator=(const CLt& value);

};

/////////////////// CLt inline methods

// constructor
inline
CLt::CLt(void)
{
}


/////////////////// end of CLt inline methods


END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_LT_HPP
/* Original file checksum: lines: 82, chars: 2268, CRC32: a4b18f6b */
