/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file NameOfSubstance.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: NameOfSubstance_.hpp


#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_NAMEOFSUBSTANCE_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_NAMEOFSUBSTANCE_HPP


// generated includes
#include <objtools/eutils/efetch/NameOfSubstance_.hpp>

// generated classes

BEGIN_eutils_SCOPE // namespace eutils::

/////////////////////////////////////////////////////////////////////////////
class CNameOfSubstance : public CNameOfSubstance_Base
{
    typedef CNameOfSubstance_Base Tparent;
public:
    // constructor
    CNameOfSubstance(void);
    CNameOfSubstance(const std::string& value);
    // destructor
    ~CNameOfSubstance(void);

    // typedef std::string TNameOfSubstance;

    /// Conversion operator to 'TNameOfSubstance' type.
    operator const TNameOfSubstance&(void) const;
    /// Assignment operator.
    CNameOfSubstance& operator=(const TNameOfSubstance& value);

private:
    // Prohibit copy constructor and assignment operator
    CNameOfSubstance(const CNameOfSubstance& value);
    CNameOfSubstance& operator=(const CNameOfSubstance& value);

};

/////////////////// CNameOfSubstance inline methods

// constructor
inline
CNameOfSubstance::CNameOfSubstance(void)
{
}

inline
CNameOfSubstance::CNameOfSubstance(const std::string& value)
{
    SetNameOfSubstance(value);
}

inline
CNameOfSubstance::operator const CNameOfSubstance::TNameOfSubstance&(void) const
{
    return GetNameOfSubstance();
}

inline
CNameOfSubstance& CNameOfSubstance::operator=(const TNameOfSubstance& value)
{
    SetNameOfSubstance(value);
    return *this;
}


/////////////////// end of CNameOfSubstance inline methods


END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_NAMEOFSUBSTANCE_HPP
/* Original file checksum: lines: 109, chars: 3150, CRC32: 4fefa5e5 */
