/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file NlmUniqueID.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: NlmUniqueID_.hpp


#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_NLMUNIQUEID_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_NLMUNIQUEID_HPP


// generated includes
#include <objtools/eutils/efetch/NlmUniqueID_.hpp>

// generated classes

BEGIN_eutils_SCOPE // namespace eutils::

/////////////////////////////////////////////////////////////////////////////
class CNlmUniqueID : public CNlmUniqueID_Base
{
    typedef CNlmUniqueID_Base Tparent;
public:
    // constructor
    CNlmUniqueID(void);
    // destructor
    ~CNlmUniqueID(void);

    // typedef std::string Tdata;

    /// Constructor from the primitive type.
    CNlmUniqueID(const Tdata& value);
    /// Assignment operator
    CNlmUniqueID& operator=(const Tdata& value);

private:
    // Prohibit copy constructor and assignment operator
    CNlmUniqueID(const CNlmUniqueID& value);
    CNlmUniqueID& operator=(const CNlmUniqueID& value);

};

/////////////////// CNlmUniqueID inline methods

// constructor
inline
CNlmUniqueID::CNlmUniqueID(void)
{
}

// data copy constructors
inline
CNlmUniqueID::CNlmUniqueID(const Tdata& value)
{
    Set(value);
}

// data assignment operators
inline
CNlmUniqueID& CNlmUniqueID::operator=(const Tdata& value)
{
    Set(value);
    return *this;
}


/////////////////// end of CNlmUniqueID inline methods


END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_NLMUNIQUEID_HPP
/* Original file checksum: lines: 104, chars: 2847, CRC32: 5b3f8cd7 */
