/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file OtherAbstract_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_OTHERABSTRACT_BASE_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_OTHERABSTRACT_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>
#include <string>

#ifndef BEGIN_eutils_SCOPE
#  define BEGIN_eutils_SCOPE BEGIN_SCOPE(eutils)
#  define END_eutils_SCOPE END_SCOPE(eutils)
#endif
BEGIN_eutils_SCOPE // namespace eutils::


// forward declarations
class CAbstractText;
class CCopyrightInformation;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class COtherAbstract_Base : public NCBI_NS_NCBI::CSerialObject
{
    typedef NCBI_NS_NCBI::CSerialObject Tparent;
public:
    // constructor
    COtherAbstract_Base(void);
    // destructor
    virtual ~COtherAbstract_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class C_Attlist : public NCBI_NS_NCBI::CSerialObject
    {
        typedef NCBI_NS_NCBI::CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        enum EAttlist_Type {
            eAttlist_Type_AAMC                   = 1,
            eAttlist_Type_AIDS                   = 2,
            eAttlist_Type_KIE                    = 3,
            eAttlist_Type_PIP                    = 4,
            eAttlist_Type_NASA                   = 5,
            eAttlist_Type_Publisher              = 6,
            eAttlist_Type_plain_language_summary = 7
        };
        
        /// Access to EAttlist_Type's attributes (values, names) as defined in spec
        static const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(EAttlist_Type)(void);
        
        // types
        typedef EAttlist_Type TType;
        typedef NCBI_NS_STD::string TLanguage;
    
        // member index
        enum class E_memberIndex {
            e__allMandatory = 0,
            e_Type,
            e_Language
        };
        typedef Tparent::CMemberIndex<E_memberIndex, 3> TmemberIndex;
    
        // getters
        // setters
    
        /// mandatory
        /// typedef EAttlist_Type TType
        ///  Check whether the Type data member has been assigned a value.
        bool IsSetType(void) const;
        /// Check whether it is safe or not to call GetType method.
        bool CanGetType(void) const;
        void ResetType(void);
        TType GetType(void) const;
        void SetType(TType value);
        TType& SetType(void);
    
        /// optional with default "eng"
        /// typedef NCBI_NS_STD::string TLanguage
        ///  Check whether the Language data member has been assigned a value.
        bool IsSetLanguage(void) const;
        /// Check whether it is safe or not to call GetLanguage method.
        bool CanGetLanguage(void) const;
        void ResetLanguage(void);
        void SetDefaultLanguage(void);
        const TLanguage& GetLanguage(void) const;
        void SetLanguage(const TLanguage& value);
        void SetLanguage(TLanguage&& value);
        TLanguage& SetLanguage(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        EAttlist_Type m_Type;
        NCBI_NS_STD::string m_Language;
    };
    // types
    typedef C_Attlist TAttlist;
    typedef NCBI_NS_STD::list< NCBI_NS_NCBI::CRef< CAbstractText > > TAbstractText;
    typedef CCopyrightInformation TCopyrightInformation;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_Attlist,
        e_AbstractText,
        e_CopyrightInformation
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 4> TmemberIndex;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// mandatory
    /// typedef NCBI_NS_STD::list< NCBI_NS_NCBI::CRef< CAbstractText > > TAbstractText
    ///  Check whether the AbstractText data member has been assigned a value.
    bool IsSetAbstractText(void) const;
    /// Check whether it is safe or not to call GetAbstractText method.
    bool CanGetAbstractText(void) const;
    void ResetAbstractText(void);
    const TAbstractText& GetAbstractText(void) const;
    TAbstractText& SetAbstractText(void);

    /// optional
    /// typedef CCopyrightInformation TCopyrightInformation
    ///  Check whether the CopyrightInformation data member has been assigned a value.
    bool IsSetCopyrightInformation(void) const;
    /// Check whether it is safe or not to call GetCopyrightInformation method.
    bool CanGetCopyrightInformation(void) const;
    void ResetCopyrightInformation(void);
    const TCopyrightInformation& GetCopyrightInformation(void) const;
    void SetCopyrightInformation(TCopyrightInformation& value);
    TCopyrightInformation& SetCopyrightInformation(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    COtherAbstract_Base(const COtherAbstract_Base&);
    COtherAbstract_Base& operator=(const COtherAbstract_Base&);

    // data
    Uint4 m_set_State[1];
    NCBI_NS_NCBI::CRef< TAttlist > m_Attlist;
    NCBI_NS_STD::list< NCBI_NS_NCBI::CRef< CAbstractText > > m_AbstractText;
    NCBI_NS_NCBI::CRef< TCopyrightInformation > m_CopyrightInformation;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool COtherAbstract_Base::C_Attlist::IsSetType(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool COtherAbstract_Base::C_Attlist::CanGetType(void) const
{
    return IsSetType();
}

inline
void COtherAbstract_Base::C_Attlist::ResetType(void)
{
    m_Type = (EAttlist_Type)(0);
    m_set_State[0] &= ~0x3;
}

inline
COtherAbstract_Base::C_Attlist::TType COtherAbstract_Base::C_Attlist::GetType(void) const
{
    if (!CanGetType()) {
        ThrowUnassigned(0);
    }
    return m_Type;
}

inline
void COtherAbstract_Base::C_Attlist::SetType(COtherAbstract_Base::C_Attlist::TType value)
{
    m_Type = value;
    m_set_State[0] |= 0x3;
}

inline
COtherAbstract_Base::C_Attlist::TType& COtherAbstract_Base::C_Attlist::SetType(void)
{
#ifdef _DEBUG
    if (!IsSetType()) {
        memset(&m_Type,UnassignedByte(),sizeof(m_Type));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Type;
}

inline
bool COtherAbstract_Base::C_Attlist::IsSetLanguage(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool COtherAbstract_Base::C_Attlist::CanGetLanguage(void) const
{
    return true;
}

inline
void COtherAbstract_Base::C_Attlist::ResetLanguage(void)
{
    m_Language = "eng";
    m_set_State[0] &= ~0xc;
}

inline
void COtherAbstract_Base::C_Attlist::SetDefaultLanguage(void)
{
    ResetLanguage();
    m_set_State[0] |= 0x4;
}

inline
const COtherAbstract_Base::C_Attlist::TLanguage& COtherAbstract_Base::C_Attlist::GetLanguage(void) const
{
    return m_Language;
}

inline
void COtherAbstract_Base::C_Attlist::SetLanguage(const COtherAbstract_Base::C_Attlist::TLanguage& value)
{
    m_Language = value;
    m_set_State[0] |= 0xc;
}

inline
void COtherAbstract_Base::C_Attlist::SetLanguage(COtherAbstract_Base::C_Attlist::TLanguage&& value)
{
    m_Language = std::forward<COtherAbstract_Base::C_Attlist::TLanguage>(value);
    m_set_State[0] |= 0xc;
}

inline
COtherAbstract_Base::C_Attlist::TLanguage& COtherAbstract_Base::C_Attlist::SetLanguage(void)
{
#ifdef _DEBUG
    if (!IsSetLanguage()) {
        m_Language = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Language;
}

inline
bool COtherAbstract_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool COtherAbstract_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const COtherAbstract_Base::TAttlist& COtherAbstract_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<COtherAbstract_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
COtherAbstract_Base::TAttlist& COtherAbstract_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    return (*m_Attlist);
}

inline
bool COtherAbstract_Base::IsSetAbstractText(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool COtherAbstract_Base::CanGetAbstractText(void) const
{
    return true;
}

inline
const COtherAbstract_Base::TAbstractText& COtherAbstract_Base::GetAbstractText(void) const
{
    return m_AbstractText;
}

inline
COtherAbstract_Base::TAbstractText& COtherAbstract_Base::SetAbstractText(void)
{
    m_set_State[0] |= 0x4;
    return m_AbstractText;
}

inline
bool COtherAbstract_Base::IsSetCopyrightInformation(void) const
{
    return m_CopyrightInformation.NotEmpty();
}

inline
bool COtherAbstract_Base::CanGetCopyrightInformation(void) const
{
    return IsSetCopyrightInformation();
}

inline
const COtherAbstract_Base::TCopyrightInformation& COtherAbstract_Base::GetCopyrightInformation(void) const
{
    if (!CanGetCopyrightInformation()) {
        ThrowUnassigned(2);
    }
    return (*m_CopyrightInformation);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_OTHERABSTRACT_BASE_HPP
